// HUNDRED POINTS - ENHANCED EDITION (DICE GAME)
// By Banjo
// banjosbbs@hotmail.com
// www.banjosbbs.blogspot.com
// Version 1.10
//
// CREDITS:
// Original script by Marspank.
// Enhanced Edition script additions and changes by Banjo.
// Dice images created by Banjo from free image resources online.
// Opponent images sourced from various free web preview galleries.
// Spanking sounds recorded and edited by Banjo.
// Dice sounds from www.freesound.org, edited by Banjo.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/hundredpoints_ee.groovy
 */
//

//Metadata
setInfos(7, "Hundred Points EE",
	"A dice rolling game with spanking penalties (requires Game Hub)",
	"Banjo, marspank",
	"v1.10", 0xFFFFFF, "en",
	["spanking", "game", "femaledom", "formale", "forfemale", "banjohub"]);

//Player setup
def player = (loadString("intro.name"))
def manlady = "man"
def boygirl = "boy"
def bratbitch = "brat"
def cockpussy = "cock"
if(loadBoolean("intro.female"))
{
	manlady = "lady"
	boygirl = "girl"
	bratbitch = "bitch"
	cockpussy = "pussy"
}

//Game setup
def gamename = "Bank, Spank or Wank"
def opponent_met = false
def opponent_played = false
def menu = 0
def quit = false
def greeting = "Ready to play?"
def spankMultiplier = 2
def strokeMultiplier = 5
def gameEndValue = 100

//Load Settings
def loadSettings = {
	if(loadBoolean("Banjo.hundredpoints.custom")) {
		spankMultiplier = loadInteger("Banjo.hundredpoints.spankMultiplier")
		strokeMultiplier = loadInteger("Banjo.hundredpoints.strokeMultiplier")
		gameEndValue = loadInteger("Banjo.hundredpoints.gameEndValue")
	}
}

//Default implements
def getLightImplement = {
	def implementList = ["ruler"]
//	if(loadBoolean("toys.ruler")) implementList+="ruler"
	if(loadBoolean("toys.slipper")) implementList+="slipper"
	if(loadBoolean("toys.plimsoll")) implementList+="plimsoll"
	if(loadBoolean("toys.spatula")) implementList+="spatula"
	if(loadBoolean("toys.spatula_wooden")) implementList+="wooden spatula"
	if(loadBoolean("toys.flyswatter")) implementList+="flyswatter"
	if(loadBoolean("toys.wooden_spoon")) implementList+="wooden spoon"
	if(loadBoolean("toys.bat")) implementList+="table tennis bat"
	if(loadBoolean("toys.bat_flyback")) implementList+="paddleball bat"
	if(loadBoolean("toys.bat_beach")) implementList+="beach tennis bat"
	if(loadBoolean("toys.slapper")) implementList+="leather slapper"
	if(loadBoolean("toys.hairbrush_plastic")) implementList+="plastic hairbrush"
	return implementList[getRandom(implementList.size())]
}
def getMediumImplement = {
	def implementList = ["hairbrush"]
//	if(loadBoolean("toys.hairbrush")) implementList+="hairbrush"
	if(loadBoolean("toys.hairbrush_paddle")) implementList+="paddle hairbrush"
	if(loadBoolean("toys.sandal")) implementList+="sandal"
	if(loadBoolean("toys.sneaker")) implementList+="sneaker"
	if(loadBoolean("toys.bat_jokari")) implementList+="battledore bat"
	if(loadBoolean("toys.paddle")) implementList+="paddle"
	if(loadBoolean("toys.sandal")) implementList+="sandal"
	if(loadBoolean("toys.paddle_rubber")) implementList+="rubber paddle"
	if(loadBoolean("toys.paddle_leather")) implementList+="leather paddle"
	if(loadBoolean("toys.paddle_plastic")) implementList+="plastic paddle"
	if(loadBoolean("toys.paddle_lexan")) implementList+="lexan paddle"
	if(loadBoolean("toys.strap_loop")) implementList+="loop strap"
	if(loadBoolean("toys.switch")) implementList+="switch"
	if(loadBoolean("toys.rod")) implementList+="curtain rod"
	if(loadBoolean("toys.martinet")) implementList+="martinet"
	return implementList[getRandom(implementList.size())]
}
def getHeavyImplement = {
	def implementList = ["bathbrush"]
//	if(loadBoolean("toys.bathbrush")) implementList+="bathbrush"
	if(loadBoolean("toys.crop")) implementList+="riding crop"
	if(loadBoolean("toys.cane")) implementList+="cane"
	if(loadBoolean("toys.cane_heavy")) implementList+="judicial cane"
	if(loadBoolean("toys.cane_otk")) implementList+="short cane"
	if(loadBoolean("toys.cane_plastic")) implementList+="plastic cane"
	if(loadBoolean("toys.cane_loop")) implementList+="loop cane"
	if(loadBoolean("toys.rugbeater")) implementList+="rugbeater"
	if(loadBoolean("toys.duster")) implementList+="duster handle"
	if(loadBoolean("toys.birch")) implementList+="birch rod"
	if(loadBoolean("toys.tawse")) implementList+="tawse"
	if(loadBoolean("toys.strap")) implementList+="strap"
	if(loadBoolean("toys.strap_studded")) implementList+="studded strap"
	if(loadBoolean("toys.belt")) implementList+="belt"
	if(loadBoolean("toys.paddle_holes")) implementList+="paddle with holes"
	if(loadBoolean("toys.cat_o_nine")) implementList+="cat-o-nine-tails"
	if(loadBoolean("toys.flogger")) implementList+="flogger"
	if(loadBoolean("toys.whip")) implementList+="whip"
	return implementList[getRandom(implementList.size())]
}
def lightImplement = getLightImplement()
def mediumImplement = getMediumImplement()
def heavyImplement = getHeavyImplement()
def lightImplementSound = "slap"
def mediumImplementSound = "smack"
def heavyImplementSound = "whack"

//Default opponent
def opponent="Gemma"
def opponent_pics = 5
def opponent_pics2 = 2
def respectTitle = "Miss"
def mistressRollDecision = 6
def mistressTotalDecision = 15
def meet1 = "Hi, I'm "+opponent+"."
def meet2 = "\n\nWhat's your name?"
def meet3 = "It's nice to meet you, "+player+"."
def meet4 = "Let's play '"+gamename+"'."
def intro1 = "Hi there!\n\nLet's play '"+gamename+"'."
def backagain1 = "Want to play '"+gamename+"' with me again?"
def backagain2 = "Back for another game of '"+gamename+"'?"
def refuse1 = "Aww, too bad!\n\nMaybe some other time?"
def goodbye1 = "Now wasn't that a fun game?\n\nCome back soon so we can play again."

//Opponents
def maxOpponents = 13
def opponent0 = "Gemma"
def opponent1 = "Sandy"
def opponent2 = "Khyanna"
def opponent3 = "Raven"
def opponent4 = "Nicole"
def opponent5 = "Gracie"
def opponent6 = "Melanie"
def opponent7 = "Ann"
def opponent8 = "Valentina"
def opponent9 = "Kitty"
def opponent10 = "Bryci"
def opponent11 = "Tyler"
def opponent12 = "Tere"
def opponent13 = "Kiara"

def opponentSet0 = {
	opponent = "Gemma"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet1 = {
	opponent = "Sandy"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet2 =  {
	opponent = "Khyanna"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet3 = 	{
	opponent = "Raven"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet4 = {
	opponent = "Nicole"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet5 = {
	opponent = "Gracie"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet6 = {
	opponent = "Melanie"
	respectTitle = "Miss"
	opponent_pics = 6
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet7 = {
	opponent = "Ann"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet8 = {
	opponent = "Valentina"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet9 = {
	opponent = "Kitty"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "My name is "+opponent+"."
	meet2 = "\n\nWho the hell are you, "+bratbitch+"?"
	meet3 = "Hmph! Another silly little "+boygirl+"?"
	meet4 = "I assume you want to play '"+gamename+"' with me?"
	intro1 = "Hello, "+boygirl+"\n\nShall we play '"+gamename+"'?"
	backagain1 = "Do you want to play '"+gamename+"' again?"
	backagain2 = "Back for another game of '"+gamename+"', "+boygirl+"?"
	refuse1 = "Then run along and don't bother me, little "+boygirl+"."
	goodbye1 = "That was rather amusing.\n\nI might enjoy playing with you again."
}

def opponentSet10 = {
	opponent = "Bryci"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 3
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet11 = {
	opponent = "Tyler"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet12 = {
	opponent = "Tere"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 4
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet13 = {
	opponent = "Kiara"
	respectTitle = "Aunty"
	opponent_pics = 7
	opponent_pics2 = 4
	mistressRollDecision = 6
	mistressTotalDecision = 15
	meet1 = "Hello there. I'm "+opponent+"... but you can call me '"+respectTitle+" "+opponent+"', young "+manlady+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

//Opponent selection menu
def opponentSelect = {
	def opponentselection = true
	while(opponentselection)
	{
		def pick_opponent = getSelectedValue("Select your opponent:", [opponent0,opponent1,opponent2,opponent3,opponent4,opponent5,opponent6,opponent7,opponent8,opponent9,opponent10,opponent11,opponent12,opponent13])
		if(pick_opponent==0) opponentSet0()
		else if(pick_opponent==1) opponentSet1()
		else if(pick_opponent==2) opponentSet2()
		else if(pick_opponent==3) opponentSet3()
		else if(pick_opponent==4) opponentSet4()
		else if(pick_opponent==5) opponentSet5()
		else if(pick_opponent==6) opponentSet6()
		else if(pick_opponent==7) opponentSet7()
		else if(pick_opponent==8) opponentSet8()
		else if(pick_opponent==9) opponentSet9()
		else if(pick_opponent==10) opponentSet10()
		else if(pick_opponent==11) opponentSet11()
		else if(pick_opponent==12) opponentSet12()
		else if(pick_opponent==13) opponentSet13()
		if(pick_opponent<(maxOpponents+1)) opponentselection = false
	}
}

//Config menu
def setCustom = {
	spankMultiplier = getInteger("Enter the multiplier for spanks.\n\n(default is 2, current is "+spankMultiplier+")",2)
	while(spankMultiplier<1) {
		spankMultiplier = getInteger("You must set the spank multiplier to at least 1.\n\n(default is 2)",2)
	}
	strokeMultiplier = getInteger("Enter the multiplier for strokes.\n\n(default is 5, current is "+strokeMultiplier+")",5)
	while(strokeMultiplier<1) {
		strokeMultiplier = getInteger("You must set the stroke multiplier to at least 1.\n\n(default is 5)",5)
	}
	gameEndValue = getInteger("Enter the number of points to end the game.\n\n(default is 100, current is "+gameEndValue+")",100)
	while(gameEndValue<10) {
		gameEndValue = getInteger("You must set the end game value to at least 10.\n\n(default is 100)",100)
	}
	save("Banjo.hundredpoints.spankMultiplier",spankMultiplier)
	save("Banjo.hundredpoints.strokeMultiplier",strokeMultiplier)
	save("Banjo.hundredpoints.gameEndValue",gameEndValue)
	save("Banjo.hundredpoints.custom",true)
	show("Settings saved.")
	wait(3)
	loadSettings()
}

def resetGame = {
	spankMultiplier = 2
	strokeMultiplier = 5
	gameEndValue = 100
	opponent_played = false
	save("Banjo.hundredpoints.spankMultiplier",spankMultiplier)
	save("Banjo.hundredpoints.strokeMultiplier",strokeMultiplier)
	save("Banjo.hundredpoints.gameEndValue",gameEndValue)
	save("Banjo.hundredpoints.custom",false)
	save("Banjo.hundredpoints.played_"+opponent0+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent1+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent2+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent3+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent4+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent5+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent6+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent7+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent8+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent9+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent10+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent11+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent12+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent13+"",opponent_played)
	show("Settings reset to defaults.\n\nGame will quit after exiting config.")
	wait(5)
	quit = true
}

def resetTotal = {
	spankMultiplier = 2
	strokeMultiplier = 5
	gameEndValue = 100
	opponent_met = false
	opponent_played = false
	save("Banjo.hundredpoints.spankMultiplier",spankMultiplier)
	save("Banjo.hundredpoints.strokeMultiplier",strokeMultiplier)
	save("Banjo.hundredpoints.gameEndValue",gameEndValue)
	save("Banjo.hundredpoints.custom",false)
	save("Banjo.hundredpoints.played_"+opponent0+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent1+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent2+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent3+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent4+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent5+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent6+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent7+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent8+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent9+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent10+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent11+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent12+"",opponent_played)
	save("Banjo.hundredpoints.played_"+opponent13+"",opponent_played)
	save("Banjo.games.met_"+opponent0+"",opponent_met)
	save("Banjo.games.met_"+opponent1+"",opponent_met)
	save("Banjo.games.met_"+opponent2+"",opponent_met)
	save("Banjo.games.met_"+opponent3+"",opponent_met)
	save("Banjo.games.met_"+opponent4+"",opponent_met)
	save("Banjo.games.met_"+opponent5+"",opponent_met)
	save("Banjo.games.met_"+opponent6+"",opponent_met)
	save("Banjo.games.met_"+opponent7+"",opponent_met)
	save("Banjo.games.met_"+opponent8+"",opponent_met)
	save("Banjo.games.met_"+opponent9+"",opponent_met)
	save("Banjo.games.met_"+opponent10+"",opponent_met)
	save("Banjo.games.met_"+opponent11+"",opponent_met)
	save("Banjo.games.met_"+opponent12+"",opponent_met)
	save("Banjo.games.met_"+opponent13+"",opponent_met)
	show("Settings reset to defaults.")
	wait(5)
	quit = true
}

def changeSettings = {
	def loopmenu = true
	while(loopmenu) {
		menu = getSelectedValue("What do you want to do?", ["Exit Config", "Customize", "Reset Game", "Total Reset"])
		if(menu==0) loopmenu = false
		else if(menu==1) setCustom()
		else if(menu==2) resetGame()
		else if(menu==3) resetTotal()
	}
}

//Basic variables and definitions

def mistressTotal = 0
def playerTotal = 0
def roundTotal = 0
def rounds = 0
def rollCount = 0
def display = ""
def imageOpponent = "opponents/"+opponent+"_intro.jpg"
def imageDice = "dice/1d6_1.png"

def displayTotals = {
	display = ""+opponent+"'s Total: "+mistressTotal+"\nYour Total: "+playerTotal+"\n"+"Current Round Total: "+roundTotal+"\nRound Rolls: "+rollCount+"\n\n\n\n\n\n\n"
}

def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}
	if ( itemKeys.isEmpty() ) return null
	return itemKeys[ getRandom(itemKeys.size()) ]
}

def playSoundDiceroll = {
	playSound("banjo/casino/die.wav")
}

def spankImplement = lightImplement
def spankSound = lightImplementSound
def spankSoundLimit = 4

def x = 0
def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	wait(2)
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("spanks/"+spankSound+(1+getRandom(spankSoundLimit))+".wav")
		wait(time)
	}
}

def stroke = {
	message, strokes, time ->
	show(""+message+"\n\n. . ")
	wait(time)
	(1..strokes).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("tom.wav")
		wait(time)
	}
}

//Fixes (in case settings are accidentally set to 0)
if(spankMultiplier<1) spankMultiplier = 1
if(strokeMultiplier<1) strokeMultiplier = 1
if(gameEndValue<1) gameEndValue = 10

//Randomly select an image
def setImageGame = {
	def imageNumber = getRandom(opponent_pics)+1
	imageOpponent = "opponents/"+opponent+"_playing"+imageNumber+".jpg"
	setImage(imageOpponent)
}

def setImageSpank = {
	def imageNumber = getRandom(opponent_pics2)+1
	setImage("opponents/"+opponent+"_spank"+imageNumber+".jpg")
}

//Show main opponent image
def setImageMain = {
	setImage("opponents/"+opponent+"_intro.jpg")
}

//setImageDice
def setImageDice = { picture, opicture ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+opicture)
	def owidth = oimage.getWidth() * 2
	def oheight = oimage.getHeight() * 2
	 
	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	def osprite = javax.imageio.ImageIO.read(new File("images/"+opicture))
	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	graphics.drawImage(osprite,10,10,owidth,oheight, null)

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

//Clear dice image
def setImageNoDice = {
	setImage(imageOpponent)
}

//Game Intro
def intro = {
	if(!loadBoolean("Banjo.games.met_"+opponent+"")) {
		opponent_met = false
		save("Banjo.games.met_"+opponent+"",true)
	} else opponent_met = true
	if(!loadBoolean("Banjo.hundredpoints.played_"+opponent+"")) {
		opponent_played = false
		save("Banjo.hundredpoints.played_"+opponent+"",true)
	} else opponent_played = true
	if(!opponent_met) {
		show(meet1+meet2)
		showButton("I'm "+player+", "+respectTitle+".")
		show(meet3)
		wait(3)
		greeting = meet4
	} else if(!opponent_played) {
		greeting = intro1
	} else {
		def backagainMessageArray = [backagain1,backagain2]
		greeting = backagainMessageArray[getRandom(2)]
	}
	def mainmenu = true
	while(mainmenu) {
		loadSettings()
		menu = getSelectedValue(greeting, ["Yes", "No", "Config"])
		if(menu==0)
			mainmenu = false
		else if(menu==1) {
			show(refuse1)
			wait(5)
			mainmenu = false
			quit = true
		}
		else if(menu==2)
			changeSettings()
	}
}

//Rules explaination
def rulesDisplay = {
	show("'"+gamename+"' is a spanking dice game played in rounds.")
	showButton("Sounds interesting, "+respectTitle+".")
	show("During their round, a player rolls a six-sided die."
		+"\n\nIf they roll anything but a 1, they earn that "
		+"many points and can roll again if they wish."
		+"\n\nIf a player stops before rolling a 1, they 'bank' the "
		+"points they've earned that round."
		+"\n\nTheir turn is then over.")
	showButton("What happens if they roll a 1?")
	show("Any time a player rolls a 1, they lose all the points "
		+"they have earned that current round, and their turn is over."
		+"\n\nHowever, they still keep the points they 'banked' in "
		+"previous rounds.")
	showButton("I understand, "+respectTitle+".")
	show("The object of the game is to be the first to 'bank' a total of "+gameEndValue+" points.")
	showButton("I see, "+respectTitle+".")
	if(spankMultiplier==1) show("There is, of course, a penalty for losing."
		+"\n\nShould you lose, you will receive a spanking with the implements of my choice."
		+"\n\nThe number of spanks you receive will be equal to the number of points "
		+"you lost by.")
	else show("There is, of course, a penalty for losing."
		+"\n\nShould you lose, you will receive a spanking with the implements of my choice."
		+"\n\nThe number of spanks you receive will be equal to the number of points "
		+"you lost by, multipled by "+spankMultiplier+".")
	showButton("What if I win, "+respectTitle+"?")
	if(strokeMultiplier==1) show("If you win, you will be allowed to masturbate."
		+"\n\nI will allow you to stroke your "+cockpussy+" a number of times equal to the "
		+"number of points you won by.")
	else show("If you win, you will be allowed to masturbate."
		+"\n\nI will allow you to stroke your "+cockpussy+" a number of times equal to the "
		+"number of points you won by, multiplied by "+strokeMultiplier+".")
	showButton("Thank you, "+respectTitle+".")
}

//Implement sound assignments
def setImplementSound = {
	if(spankImplement=="hairbrush") spankSound = "smack"
	else if(spankImplement=="paddle hairbrush") spankSound = "smack"
	else if(spankImplement=="plastic hairbrush") spankSound = "slap"
	else if(spankImplement=="ruler") spankSound = "whap"
	else if(spankImplement=="spatula") spankSound = "slap"
	else if(spankImplement=="wooden spatula") spankSound = "slap"
	else if(spankImplement=="flyswatter") spankSound = "slap"
	else if(spankImplement=="wooden spoon") spankSound = "whap"
	else if(spankImplement=="bathbrush") spankSound = "whack"
	else if(spankImplement=="slipper") spankSound = "smack"
	else if(spankImplement=="sandal") spankSound = "smack"
	else if(spankImplement=="plimsoll") spankSound = "smack"
	else if(spankImplement=="sneaker") spankSound = "smack"
	else if(spankImplement=="leather slapper") spankSound = "slap"
	else if(spankImplement=="leather paddle") spankSound = "slap"
	else if(spankImplement=="table tennis bat") spankSound = "smack"
	else if(spankImplement=="paddleball bat") spankSound = "smack"
	else if(spankImplement=="battledore bat") spankSound = "whack"
	else if(spankImplement=="beach tennis bat") spankSound = "smack"
	else if(spankImplement=="paddle") spankSound = "whack"
	else if(spankImplement=="paddle with holes") spankSound = "whack"
	else if(spankImplement=="lexan paddle") spankSound = "whack"
	else if(spankImplement=="plastic paddle") spankSound = "smack"
	else if(spankImplement=="rubber paddle") spankSound = "smack"
	else if(spankImplement=="strap") spankSound = "belt"
	else if(spankImplement=="studded strap") spankSound = "belt"
	else if(spankImplement=="loop strap") spankSound = "slap"
	else if(spankImplement=="belt") spankSound = "belt"
	else if(spankImplement=="tawse") spankSound = "flog"
	else if(spankImplement=="cane") spankSound = "thwack"
	else if(spankImplement=="judicial cane") spankSound = "thwack"
	else if(spankImplement=="duster handle") spankSound = "thwack"
	else if(spankImplement=="short cane") spankSound = "thwack"
	else if(spankImplement=="plastic cane") spankSound = "thwack"
	else if(spankImplement=="loop cane") spankSound = "thwack"
	else if(spankImplement=="riding crop") spankSound = "thwip"
	else if(spankImplement=="birch rod") spankSound = "thwip"
	else if(spankImplement=="curtain rod") spankSound = "thwip"
	else if(spankImplement=="switch") spankSound = "thwip"
	else if(spankImplement=="rugbeater") spankSound = "thwack"
	else if(spankImplement=="martinet") spankSound = "thwip"
	else if(spankImplement=="flogger") spankSound = "flog"
	else if(spankImplement=="cat-o-nine-tails") spankSound = "flog"
	else if(spankImplement=="whip") spankSound = "flog"
	else spankSound="smack"
}

def setImplementSounds = {
	spankImplement = lightImplement
	setImplementSound()
	lightImplementSound = spankSound
	spankImplement = mediumImplement
	setImplementSound()
	mediumImplementSound = spankSound
	spankImplement = heavyImplement
	setImplementSound()
	heavyImplementSound = spankSound
}

//Opponent's AI
def mistressDecision = { decision ->
	if(mistressTotal + roundTotal >= 100) return true
	switch(decision){
		case 0:
			if(rollCount >= mistressRollDecision) return true
			else if(roundTotal > 25) return true
			else return false
		case 1:
			if(roundTotal >= mistressTotalDecision) return true
			else return false
		case 2:
			if(rollCount > 1 && roundTotal >= (7-rollCount)*(rollCount)) return true
			else return false
		case 3:
			if(getRandom(6) == 0) return true
			else return false
	}
}

//Opponent's round
def mistressRound = {
	def keepPlaying = true
	roundTotal = 0
	
	def decisionRule = getRandom(4)

	rollCount = 0

	while(keepPlaying)
	{
		playSoundDiceroll()
		def diceRoll = getRandom(6)+1
		imageDice = "dice/1d6_"+diceRoll+".png"
		setImageDice(imageOpponent,imageDice)
		rollCount++
		if(diceRoll == 1)
		{
			def oneMessages = ["Looks like you got lucky... I rolled a 1!","Oh no! I rolled a 1!"
				,"I can't believe it! I got a 1!","I got a 1 this time, but next round is mine!"]
			displayTotals()
			show(display+oneMessages[getRandom(4)]+"\n\n\n\n\n\n\n.")
			wait(10)
			roundTotal = 0
			keepPlaying = false
		}
		else
		{
			def rollMessages = ["Nice, I rolled a ","Looks like I rolled a ","I rolled a "]
			displayTotals()
			show(display+rollMessages[getRandom(3)]+diceRoll+".\n\n\n\n\n\n\n\n.")
			roundTotal += diceRoll;
			wait(5)
			def totalMessages = ["My new round total is ","That brings my total to ","Now I have "]

			setImageNoDice()
			
			if(mistressDecision(decisionRule))
			{
				def stopMessages = ["That's good enough for this round, time to cash in.",
					"That's enough for this round.","I'll take those points.",
					"I'm not going to push my luck any further."]
				displayTotals()
				show(display+totalMessages[getRandom(3)]+roundTotal+" points.\n\n"+stopMessages[getRandom(4)]
					+"\n\n\n\n\n\n.")
				wait(5)
				keepPlaying = false
			}
			else
			{
				def playMessages = ["Hmm... not quite enough. I'm going to keep rolling.",
					"I think I will press my luck...","No time to stop. Have to keep rolling.",
					"I'm going to roll again. I need to build up more points to spank you with!"]
				displayTotals()
				show(display+totalMessages[getRandom(3)]+roundTotal+" points.\n\n"+playMessages[getRandom(4)]
					+"\n\n\n\n\n\n.")
				wait(5)
				keepPlaying = true
			}
		}
	}
	def passMessages
	setImageNoDice()
	if(roundTotal == 0)
	{
		if(mistressTotal >= playerTotal)
		{
			passMessages = ["Here's your chance to catch up. Don't blow it by rolling too much!",
				"Guess I gave you a good chance to get out of the hole.",
				"Too bad I couldn't increase my lead this round.","Well, I guess it's your turn now."]
		}
		else
		{
			passMessages = ["Shoot, now you can build up the lead even more!",
				"You know you wanted me to catch up so I could spank you... don't lie!",
				"This might be your chance to win some wanking... don't blow it!",
				"Guess I'll have to make up the gap next round."]
			
		}
		displayTotals()
		show(passMessages[getRandom(4)])
		wait(8)
	}
	else
	{
		passMessages = ["Looks like you have some work to do. I got ",
			"Not a bad round for me, I got ","I am happy taking "]
		mistressTotal += roundTotal
		displayTotals()
		show(display+passMessages[getRandom(3)]+roundTotal+" points.\n\n\n\n\n\n.")
		wait(10)
	}
}

//Player's round
def playerRound = {
	roundTotal = 0
	rollCount = 0
	def keepPlaying = true
	def diceRoll

	def messages

	while(keepPlaying)
	{
		playSoundDiceroll()
		diceRoll = getRandom(6)+1
		imageDice = "dice/1d6_"+diceRoll+".png"
		setImageDice(imageOpponent,imageDice)
		rollCount++
		if(diceRoll == 1)
		{
			if(rollCount == 1)
			{
				messages = ["Poor baby! You got a 1 on your first roll!"
					,"Wow, you're unlucky! A 1 on the first roll!"
					,"A 1 on the first roll? Someone wants to get their butt spanked!"]
			}
			else
			{
				messages = ["Aww! You rolled a 1, sweetie!\nGuess you got too greedy."
					,"I'm so glad you rolled a 1.\nYour total was starting to worry me!"
					,"Looks like this round is over for you.\nYou just rolled a 1!"]
			}
			roundTotal = 0
			displayTotals()
			show(display + messages[getRandom(3)]+"\n\n\n\n\n\n\n.")
			if(mistressTotal < gameEndValue)showButton("Your turn, "+respectTitle+".")
			else showButton("I couldn't catch up, "+respectTitle+".")
			setImageNoDice()
			keepPlaying = false
			
		}
		else
		{
			roundTotal += diceRoll
			displayTotals()
			if(getBoolean(display+"You rolled a "+diceRoll+", which brings your round total to "+roundTotal+"."
					+"\nWhat do you want to do?\n\n\n\n\n\n\n.","Roll","Stay"))
			{
				//show("So you are going to roll again? Good Luck!")
				//wait(5)
				keepPlaying = true
			}
			else
			{
				//show("Not going to keep pressing? Ok.")
				//wait(5)
				keepPlaying = false
			}
			setImageNoDice()
		}
	}
	if(roundTotal != 0)
	{
		playerTotal += roundTotal
		displayTotals()
		show(display+"You got "+roundTotal+" points that round. That brings your grand total to "+playerTotal+"."
			+"\n\n\n\n\n\n\n.")
		wait(10)
	}
}

//Opponent won
def victoryMistress = {
	setImageGame()
	show("Looks like I win, you naughty "+boygirl+". Now it's time for your spanking!"
		+"\n\nBare your bottom, young "+manlady+".")
	showButton("Yes, "+respectTitle+".")

	def totalSpanks = (mistressTotal - playerTotal)*spankMultiplier
	def spankRounds = (int) totalSpanks / 20
	def leftoverSpanks = totalSpanks % 20

	//lightImplement = getLightImplement()
	mediumImplement = getMediumImplement()
	heavyImplement = getHeavyImplement()
	setImplementSounds()

	def thirdLeft = (int) spankRounds*(2.0/3)+1

	setImageGame()
	show("We will start with the "+mediumImplement+".")
	spankSound = mediumImplementSound
	showButton("Ready, "+respectTitle+".")
	def i=1
	while(i <= spankRounds)
	{
		if(i == thirdLeft && i > 2)
		{
			setImageGame()
			show("Time to switch over to the "+heavyImplement+".")
			spankSound = heavyImplementSound
			showButton("Got it, "+respectTitle+".")
		}
		if(i == spankRounds)
		{
			setImageGame()
			spank("Final Round, really HARD!",20+leftoverSpanks,2)
		}
		else
		{
			setImageGame()
			spank("Alternate cheeks... HARD!",20,1)
		}
		i++
	}
	if(spankRounds == 0)
	{
		setImageGame()
		show("Lucky you! Not even a full 20 swats... but you still have some coming.")
		wait(5)
		setImageGame()
		spank("Alternate cheeks, HARD!",leftoverSpanks,1)
	}
	show("Ouch! That bottom looks sore, "+player+"!\n\nStill, that's the price of losing, young "+manlady+"... "
		+"and spanking you is so much fun!")
	showButton("Yes, "+respectTitle+".")
}

//Player won
def victoryPlayer = {
	setImageGame()
	show("I can't believe you beat me!\n\nWell, I guess you've earned the chance to wank."
		+"\n\nShow me that "+cockpussy+" of yours, young "+manlady+", and get ready for your reward.")
	showButton("Ready, "+respectTitle+".")

	def totalStrokes = (playerTotal - mistressTotal)*strokeMultiplier
	def strokeRounds = (int) totalStrokes / 50
	def remainingStrokes = totalStrokes % 50

	def firstThird = (int) strokeRounds*(1.0/3)+1
	def finalThird = (int) strokeRounds*(2.0/3)+1

	def strokeTime = 1

	def message = "Slow strokes."

	def i=1
	while(i <= strokeRounds)
	{
		if(i == firstThird && i >= 2)
		{
			setImageGame()
			strokeTime = 0.75
			message = "Medium strokes."
		}
		else if(i==finalThird && i>=4)
		{
			setImageGame()
			strokeTime = 0.5
			message = "Faster strokes."
		}
		else if(i == strokeRounds && i > 5)
		{
			setImageGame()
			strokeTime = 0.25
			message = "Fast strokes!"
		}
		if(i == strokeRounds) stroke(message,50+remainingStrokes,strokeTime)
		else stroke(message,50,strokeTime)
		i++
	}
	if(strokeRounds == 0)
	{
		strokeTime = 2
		setImageGame()
		show("Poor baby! You couldn't even earn 50 strokes!"+
			"\n\nDon't worry, I will make this little wank session last for you.")
		wait(5)
		setImageGame()
		stroke("Make sure you savor these!",remainingStrokes,strokeTime)
	}
	show("Did you enjoy that, "+player+"?\n\nI was looking forward to spanking you, "
		+"but I suppose you did win your reward fair and square... this time!")
	showButton("Thank you, "+respectTitle+".")
}

//Mistress chooses implements
def pickImplementsMistress = {
	//lightImplement = getLightImplement()
	mediumImplement = getMediumImplement()
	heavyImplement = getHeavyImplement()
}

//Player chooses implements
def pickImplementsPlayer = {
	//lightImplement = getString("Enter a light implement.", lightImplement)
	mediumImplement = getString("Enter a medium implement.", mediumImplement)
	heavyImplement = getString("Enter a heavy implement.", heavyImplement)
}

//Implement selection
def pickImplementsChoice = {
	if(getBoolean("Do you want to me to pick the implements for you, based on what you have?\n\nOr do you want to choose them yourself?",
	"You pick","I'll pick")) pickImplementsMistress()
	else pickImplementsPlayer()
}

def pickImplements = {
	pickImplementsChoice()
	setImplementSounds()
	//show("Okay. Go and fetch the "+lightImplement+", "+mediumImplement+" and the "+heavyImplement+" and set them all close by."
	//	+"\n\nIf you lose the game, that's what you're getting spanked with, "+player+", so having them within sight might help you focus.")
	show("Okay. Go and fetch the "+mediumImplement+" and the "+heavyImplement+" and set them close by."
		+"\n\nIf you lose the game, that's what you're getting spanked with, "+player+", so having them within sight might help you focus.")
	showButton("Yes, "+respectTitle+".")
}

//Install Check
def installed = loadBoolean("Banjo.games.installed")
if(installed==null) {
	installed = false
	save("Banjo.games.installed",installed)
}

def coreScript = new File("scripts/Banjo/gamehub.groovy")
if(coreScript.exists()) {
	installed = true
	save("Banjo.games.installed",installed)
}
else {
	installed = false
	save("Banjo.games.installed",installed)
}
if(!installed) {
	show(null)
	setImage(null)
	if(getBoolean("CORE FILES NOT FOUND!\n\n"
		+"This game requires the download of a 'core' pack of opponents, images, sounds and files that is shared by other games in this series."
		+"To download the needed files, simply go to the SexScripts website script database and search for 'Game Hub' (or the script tag 'banjohub').\n\n"
		+"The script downloads can be found at:\n\n"
		+"http://ss.deviatenow.com/scripts.php\n\n"
		+"Apologies for the inconvenience!"
		+"", "Go to Webpage","Exit")) {
			if(isConnected()) {
				useUrl("http://ss.deviatenow.com/scripts.php")
				getString("Your internet browser should have opened the correct download page.\n\n"
					+"If not, please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
			else {
				getString("Cannot connect to the internet (your firewall may be blocking this operation)\n\n"
					+"Please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
		}
		show(null)
		setImage(null)
		if(loadBoolean("setting.newsetup")) {
			if(loadBoolean("setting.reload")) {
				return "system/welcome"
			}
			else {
				return "system/exit"
			}
		}
		else {
			return null
		}
}

//Start of script
show(null)
setImage(null)
opponentSelect()
show(null)
setImageMain()
wait(1)
intro()
while(!quit) {
	if(getBoolean("Do you want to review the rules?","Yes","I know them"))
	{
		rulesDisplay()
		while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
		{
			rulesDisplay()
		}
	}
	pickImplements()
	show("Now let's play!")
	wait(5)
	while(mistressTotal < gameEndValue && playerTotal < gameEndValue) {
		rounds++
		setImageGame()
		if(rounds == 1) show("I'll go first, but don't worry... we'll both get the same number of turns.")
		else show("My turn now.")
		wait(5)
		mistressRound()
		if(mistressTotal > gameEndValue) {
			show("This is going to be your last chance to score points."
			+"\n\nBetter make it count!")
			wait(5)
		}
		setImageGame()
		show("Your turn.")
		showButton("Roll.")
		playerRound()
	}
	if(mistressTotal > playerTotal) {
		victoryMistress()
	}
	else if(playerTotal > mistressTotal) {
		victoryPlayer()
	}
	setImageMain()
	show(goodbye1)
	showButton("Goodbye, "+respectTitle+".")
	quit = true
}
setImage(null)
show(null)
def quitGame = true
if(loadBoolean("Banjo.games.hub")) {
	if(getBoolean("Return to Game Hub?","Yes","No")) {
		quitGame = false
		save("Banjo.games.hub",false)
		return "Banjo/gamehub"
	} else save("Banjo.games.hub",false)
}
if(quitGame) {
	if(loadBoolean("setting.newsetup")) {
		if(loadBoolean("setting.reload")) {
			return "system/welcome"
		}
		else {
			return "system/exit"
		}
	}
	else {
		return null
	}
}

//END OF SCRIPT
